

// LCD BEKTS >>
sbit LCD_RS at RA0_Bit;
sbit LCD_EN at RA1_Bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;

sbit LCD_RS_Direction at TRISA0_Bit;
sbit LCD_EN_Direction at TRISA1_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;
// LCD BEKTS <<

//Billentyzet bekts >>
unsigned short keydata = 0, special = 0, down = 0;

sbit PS2_Data            at RA2_bit;
sbit PS2_Clock           at RA3_bit;
sbit PS2_Data_Direction  at TRISA2_bit;
sbit PS2_Clock_Direction at TRISA3_bit;
//Billentyzet bekts <<

char lcdsor,lcdoszlop;
bit lcdtele;
char delay;

void main()
{
TRISA = 0;
TRISB = 0;
PORTA = 0b00110000;
PORTB = 0b00000000;
CMCON = 0;
ANSEL = 0;

   LCD_Init();
  Delay_ms(100);
  LCD_CMD(_LCD_CLEAR);
  LCD_CMD(_LCD_CURSOR_OFF);
  //LCD_CMD(_LCD_RETURN_HOME);
  lcdsor=1;
  lcdoszlop=1;
  lcdtele=0;
  Delay_ms(20);
  Ps2_Config();                                       // PS/2 Csatlakozs billentyzet betltse
  Delay_ms(100);                                      // Vrakozik a billentyzet betltsre


 do
 {
  if (Ps2_Key_Read(&keydata, &special, &down)) //HA megnyomtam a billentyzetet
  {
  if (down && (keydata >= 32))            // nem funkci billentyt (ALT,CTRL,TAB stb) nyomtam le
  {
     if (lcdtele == 1)
     {
     lcdtele=0;
     lcdoszlop=1;
     lcdsor=1;
     LCD_CMD(_LCD_CLEAR);
     Delay_ms(5);
     }


     LCD_Chr(lcdsor,lcdoszlop,keydata);
     lcdoszlop++;

     if (lcdoszlop>=17)
     {
     lcdoszlop=1;
     lcdsor++;
     }

     if (lcdsor >=3)
     {
     lcdtele=1;
     }

  }

  if (down && (keydata == 16))                    // BACKSPACE
  {
      if(lcdoszlop!=1)
    {
    lcdoszlop--;
    LCD_Chr(lcdsor,lcdoszlop,32);
    }

    if(lcdoszlop == 1 && lcdsor == 2 )
    {
    LCD_Chr(1,16,32);
    lcdsor=1;
    lcdoszlop=16;
    }


  }
  if (down && (keydata == 27))                    //  ESC
  {
     lcdtele=0;
     lcdoszlop=1;
     lcdsor=1;
     LCD_CMD(_LCD_CLEAR);
     Delay_ms(5);
  }
  if (down && (keydata == 13))                    //  ENTER
  {
     if(lcdsor == 1)
     {
     lcdoszlop=1;
     lcdsor=2;
     }
  }
 }
    if(delay >= 250)
    {
    delay=0;
    }
    else
    {
    delay++;
    }
    Delay_ms(1);                                      // debounce
  } while (1);
}